


//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO

#define FOUR_PORT_SINE_MODE
#define  MULTI_PWM_USED
//#define UART_IS_USED

//http://www.engbedded.com/fusecalc/
//http://www.engbedded.com/fusecalc

// Low Fuse=0xBF   High Fuse= 0xCF

//alternate  Low Fuse=0x9E   High Fuse= 0xEF
#define DATUM		"14.01.2015"
#define UHRZEIT		"12:00"
#define HARDWARE	"AVR ATMega16 V1.0_2011 Board"
#define SOFTWARE	"Multi Sinus PWM"
#define AUTOR		"Christof Ermer"
#define IHAVENOBRAIN "I have no brain."	
#define USEYOURS		"Use your own"
#define BAUDRATE	"9600,8,N,1"
/*
#define UART_BAUD_RATE	9600
in makefile !!! ->  F_CPU  16000000 
in makefile !!! ->   MCU = atmega16
*/
/*
HYSTORY 
4.2013 Auslagerung aller Ballastfunktionen wie UART STRfuntionen in TxtFunc.c
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "avr_register.h"		//with Hardware assigns
#include "main.h"		//witdh Hardware assigns
#include "uart.h"
#include "TxtFunc.h"



// Hardwareassignment
#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	19200
//#define UART_BAUD_RATE	57600

#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
#endif

//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };

volatile uint32_t gu32_Ticks; //T2 timeCounter, only NN_Counter for Keypressings
uint8_t gu8ProgMode = 0;


#define SINE_ARRAY_SIZE	150

static uint8_t gu8aSine[4][ SINE_ARRAY_SIZE ]; // 7 PWMs#


#define SINE_RESOLUTION		256
#define U_FOLLOWER_OFFSET	36
void RechneSin(uint8_t u8SinNr, uint8_t u8Size, uint8_t u8Faktor) // NR + --> SINE_ARRAY_SIZE
{
uint8_t u8SUm = U_FOLLOWER_OFFSET + ((256/2.0) - U_FOLLOWER_OFFSET);
uint8_t u8Mult = ((256 - U_FOLLOWER_OFFSET) / 2.0);
uint8_t u8NN;
for(u8NN = 0; u8NN < u8Size; u8NN++)
// 1/3 * sin(3* 2* Pi_M * t)
	{
//	gu8aSine[u8SinNr][u8NN] =round( 146.0 + 109.0 *sin(2.0*M_PI*(u8NN/fSize)) );
	gu8aSine[u8SinNr][u8NN] =round( 127.0 + 126.0 * 1/(u8Faktor*1.0)* sin(u8Faktor * 2.0 * M_PI*(u8NN/(u8Size*1.0))) );
	wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	};
};

volatile uint8_t gu8ComNN=0;
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
ISR( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
gu32_Ticks++;

#ifdef UART_IS_USED
gu8ComNN++;
if( !(gu8ComNN % 20) )
	{
	UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
	};
#endif
};



#define MULTI_SERVO_PORT PORTC

volatile uint8_t gu8AMpCnt;// 16MHhz/65535 = 244.14 | 1/244.14 = 4.096ms
volatile uint8_t gu8ResolutionCnt;// 16MHhz/65535 = 244.14 | 1/244.14 = 4.096ms
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
ISR( TIMER0_OVF_vect ) //TIMER0_COMP_vect oder SIGNAL--INTERRUPT(SIG_OVERFLOW0) = mit SEI am Anfang
// *******************************************************************
{

#ifdef FOUR_PORT_SINE_MODE
gu8ResolutionCnt++;
gu8ResolutionCnt %= SINE_ARRAY_SIZE;
#endif

#ifdef MULTI_PWM_USED	
gu8AMpCnt++;
// TRick: u8T0_Runs von Runs
//sei();
if( !gu8AMpCnt ) // also 0
	{
	gu8ResolutionCnt++;
	
	MULTI_SERVO_PORT |= 0x0F; // ALLES ON		
	gu8ResolutionCnt %= SINE_ARRAY_SIZE;
	};	
#endif
	
	
#ifdef FOUR_PORT_SINE_MODE
PORTA = gu8aSine[0][gu8ResolutionCnt];
PORTB = gu8aSine[1][gu8ResolutionCnt];
PORTC = gu8aSine[2][gu8ResolutionCnt];
PORTD = gu8aSine[3][gu8ResolutionCnt];
#endif

#ifdef MULTI_PWM_USED	
PORTA = gu8aSine[0][gu8ResolutionCnt];
PORTB = gu8aSine[1][gu8ResolutionCnt];
//SO ist es das schnellste etwa 110000 mainloops
if( gu8aSine[0][gu8ResolutionCnt] == gu8AMpCnt )	{MULTI_SERVO_PORT &= 0xFE;};
if( gu8aSine[1][gu8ResolutionCnt] == gu8AMpCnt )	{MULTI_SERVO_PORT &= 0xFD;};
if( gu8aSine[2][gu8ResolutionCnt] == gu8AMpCnt )	{MULTI_SERVO_PORT &= 0xFB;};
if( gu8aSine[3][gu8ResolutionCnt] == gu8AMpCnt )	{MULTI_SERVO_PORT &= 0xE7;};
#endif

};



// *************************************
void StartTimer0(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher

cli();
TIMSK &= ~(TIMSK_TOIE0_FLAG | TIMSK_OCIE0_FLAG);
//OCR0 = 0;
//TCNT0 = 0;  //Timer MAX =
//16MhZ7256 / 64 = 976,5625  = 1/n = 0,9765625
// CTC lst OCRx int aus
//TCCR0 = TCCR2_CLK_8; // TCCR0_CLK_0; // 
#define TCCR0_CLK_0		0x01
TCCR0 = TCCR0_CLK_0; // TCCR0_CLK_0; // 
//TIMSK |= TIMSK_TOIE0_FLAG TIMSK_OCIE0_FLAG ; // TIMSK_TOIE0_FLAG zum lschen setzen! 
TIMSK |= TIMSK_TOIE0_FLAG;// TIMSK_OCIE0_FLAG ; // TIMSK_TOIE0_FLAG zum lschen setzen!
SREG = sreg;
sei();
};

	

// *************************************
void StartTickTimer(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
//gu32_Ticks = 0;
//OCR2 = 0;
//TCNT2 = 0;  //Timer MAX = TOP Compare
//TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};



#ifdef UART_USE_ENABLED	
// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{
// zerlege UART RX Str inseine Delimitrer Bestandteile 
TokensRXStr( pcStrOrder ); //und lege diese in gsCmd.ucaCmd ab

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SPA") ) )
	{
	DDRA=0XFF; //OUTPUTs
	PORTA = (uint8_t)gsCmd.fCmdVal_1;
	};

if( !strcasecmp_P( gsCmd.ucaCmd,  PSTR("RPA") ) )
	{
	DDRA=0X00; //INPUTs
	PORTA = 0X00; // PullUp AUS
	PrintLongCR( PINA );
	};	
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SPB") ) )
	{
	DDRB=0XFF; //OUTPUTs
	PORTB = (uint8_t)gsCmd.fCmdVal_1;
	};

if( !strcasecmp_P( gsCmd.ucaCmd,  PSTR("RPB") ) )
	{
	DDRB=0X00; //INPUTs
	PORTB = 0X00; // PullUp AUS
	PrintLongCR( PINB );
	};	
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SPC") ) )
	{
	DDRC=0XFF; //OUTPUTs
	PORTC = (uint8_t)gsCmd.fCmdVal_1;
	};

/*
if( !strcasecmp_P( gsCmd.ucaCmd,  PSTR("RPC") ) )
	{
	DDRC=0X00; //INPUTs
	PORTC = 0X00; // PullUp AUS
	PrintLongCR( PINC );
	};	
*/	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SPD") ) )
	{
	DDRD=0XFF; //OUTPUTs
	PORTD = (uint8_t)gsCmd.fCmdVal_1;
	};

if( !strcasecmp_P( gsCmd.ucaCmd,  PSTR("RPD") ) )
	{
	DDRD=0X01; //INPUTs
	PORTD = 0X00; // PullUp AUS
	PrintLongCR( PIND );
	};	

	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )    //ping
	{	
	Print_PStrCR( PSTR("Multi PWM") );	
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TT") ) )
	{
	PrintLongCR( gu32_Ticks );
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("RR") ) )
	{
	gu32_Ticks = 0; //Reset TickCounter ( nur so eine Spielerei )
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MM") ) )
	{
	PrintLongCR( gu8ProgMode ); // zeige mir an welche Status das ProgModeFlag hat
	};

};
#endif


// *******************************************************************
int main(void)
// *******************************************************************
{
volatile static uint32_t u32Now;
//static uint16_t u16Toggle;

//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
#ifdef FOUR_PORT_SINE_MODE
DDRA = 0xFF;
PORTA = 0x00;

DDRB = 0xFF;
PORTB = 0x00;

DDRC = 0xFF;  // Alle Bits von PORTC sind Ausgnge
PORTC = 0x00;

DDRD = 0xFF;	
PORTD = 0x02; //TX
#endif

//SFIOR = (1<<PUD); //Pullup Disable

//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
#ifdef UART_IS_USED
ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );
sei();

Print_PStrCR( PSTR(HARDWARE) );
Print_PStrCR( PSTR(SOFTWARE) );

Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(DATUM) );
Print_PStrCR( PSTR(IHAVENOBRAIN) );
Print_PStrCR( PSTR(USEYOURS) );
uart_puts_p( PSTR("UART-Baud="));
Print_PStrCR( PSTR(BAUDRATE) );
#endif


StartTickTimer();	//8 Bit Timer 2 = MS Tick Counter
StartTimer0();
sei();


RechneSin(0,SINE_ARRAY_SIZE,1);
RechneSin(1,SINE_ARRAY_SIZE,3);
RechneSin(2,SINE_ARRAY_SIZE,5);
RechneSin(3,SINE_ARRAY_SIZE,7);
u32Now = 0;
gu32_Ticks = 0;
// ************ MAIN LOOP FOR EVER *********************
for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
	{	
 	wdt_reset(); //WATCHDOG!
	//Hier kann was gemacht werden jede 1 Sekunde
/*

	if( (gu32_Ticks - u32Now) > 244 ) 	
		{
		u32Now = gu32_Ticks; //Zeit merken !!		
		uart_putc('*');
		}; // Tickcounter
*/
//UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
	}; //main loop Ende
};
// ******************* MAIN END ********************************************
