

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER


#define TIMER_TICK_USED

#define UART_BAUD_RATE 9600
	
#define SYSCLK_256	(SYSCLK / 256) // =  62500 //z.B.Timer2 berlauf / 256  / Teilerfaktor

#define DISABLE_ALL_PULLUP_MAC	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL_MAC	(SFIOR &= ~(_BV(PUD)));

#define WDTO_2S   7 //WatchDog
//PORT_ASSIGMNEMTS
//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3

//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt


//TIMER
#define TCCR0_CLK_0		0x01

#define TIMSK_TOIE0_FLAG	0x01
#define TIMSK_OCIE0_FLAG	0x02
#define TIMSK_TOIE1_FLAG	0x04
#define TIMSK_OCIE1B_FLAG	0x08
#define TIMSK_OCIE1A_FLAG	0x10
#define TIMSK_TICIE1_FLAG	0x20
#define TIMSK_TOIE2_FLAG	0x40	//#define TOIE2 6     (1 << TOIE2)
#define TIMSK_OCIE2_FLAG	0x80

#define TIMSK_T0_CLR_ALL_MASK 0b11111100
#define TIMSK_T1_CLR_ALL_MASK 0b11000011
#define TIMSK_T2_CLR_ALL_MASK 0b00111111


#define TIFR_TOV0_TIMER_OVERFLOW_FLAG	0x01
#define TIFR_OCF0_OUT_PCOMPARE_FLAG		0x02
#define TIFR_TOV1_TIMER_OVERFLOW_FLAG	0x04
#define TIFR_OCF1A_OUTP_COMPARE_A_FLAG	0x10
#define TIFR_OCF1B_OUTP_COMPARE_B_FLAG	0x08
#define TIFR_TOV2_TIMER_OVERFLOW_FLAG	0x40
#define TIFR_OCF2_OUTP_COMPARE_FLAG		0x80

//Aufzaehlbezeichner
#define RX_BITNR	PD0 //0
#define TX_BITNR	PD1	//1

extern volatile  uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
extern void CheckOrder(char *pcStrOrder); //von gcaRxStr

#endif  //MAIN_HEADER
